## seqan 1.3.1

=== apps/Makefile ===
SEQAN_BASE = ..

# Link against runtime library on Linux systems
OS_NAME=$(shell uname)
ifeq ($(OS_NAME),Linux)
  LDFLAGS += -lrt
endif


tbb_root?=../extra/tbb

#check, if tbb_root is not absolute path (the filter keeps only /* paths)
ifeq ($(filter /% $(SLASH)%, $(subst :, ,$(tbb_root)) ),)
    # also changes related variables like work_dir
    override tbb_root := $(CWD)$(SLASH)..
    export TBB21_INSTALL_DIR := $(tbb_root)
endif

# explicitly compile for a 32 or 64 bit platform
#CXXFLAGS += -m32
#CXXFLAGS += -m64

CXXFLAGS += -I$(SEQAN_BASE)
#CXXFLAGS += -I~/Documents/Development/
CXXFLAGS += -O9 -fopenmp -march=native -DSEQAN_ENABLE_DEBUG=0
#CXXFLAGS += -O0 -g -fopenmp -DSEQAN_ENABLE_DEBUG=1
CXXFLAGS += -pedantic -W -Wall -Wno-variadic-macros
CXXFLAGS += -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64
CXXFLAGS += -DSEQAN_ENABLE_TESTING=0
CXXFLAGS += -static
CXXFLAGS += ${CXXEXTRAFLAGS}

# Intel Threading Building Blocks
#CXXFLAGS += -I$(SEQAN_BASE)/extra/tbb/include/
#LDFLAGS += -L$(SEQAN_BASE)/extra/tbb/build/macos_em64t_gcc_cc4.0.1_os10.5.5_debug/ -ltbb_debug -lpthread

TARGETS = dfi/dfi seqan_tcoffee/seqan_tcoffee seqcons/seqcons razers/paramChooser razers/razers razers2/razers pair_align/pair_align micro_razers/micro_razers tree_recon/tree_recon #transquant/transquant

all:           check_seqan_base $(TARGETS)
dfi:           check_seqan_base dfi/dfi
fiona:         check_seqan_base fiona/fiona
razers:        check_seqan_base razers/razers razers/paramChooser
razers2:       check_seqan_base razers2/razers
razers3:       check_seqan_base razers3/razers
micro_razers:  check_seqan_base micro_razers/micro_razers
seqan_tcoffee: check_seqan_base seqan_tcoffee/seqan_tcoffee
seqcons:       check_seqan_base seqcons/seqcons
pair_align:    check_seqan_base pair_align/pair_align
tree_recon:    check_seqan_base tree_recon/tree_recon
transquant:    check_seqan_base transquant/transquant transquant/rectifier transquant/transsplice
insegt:        check_seqan_base insegt/insegt

check_seqan_base:
	@if [ ! -d "$(SEQAN_BASE)/seqan" ]; then \
		echo "The directory $(SEQAN_BASE)/seqan could not be found!"; \
		exit 1; \
	fi

clean:
	rm -f $(TARGETS) $(TARGETS:=.o)

=== cmake/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6)
project (Seqan)

################################################################################
# Load Package Finder Modules
################################################################################

# Add FindTBB directory to CMake's module path
set(CMAKE_MODULE_PATH
    "${CMAKE_CURRENT_SOURCE_DIR}/CMake/"
    ${CMAKE_MODULE_PATH})
find_package (PythonInterp)

# Hacky conditional inclusion of samtools.
find_package(ZLIB QUIET)
if (ZLIB_FOUND)
  set(SAMTOOLS_FOUND "1")
  set(SAMTOOLS_CXX_FLAGS "-DSEQAN_HAS_SAMTOOLS=1")
  set(SAMTOOLS_LIBRARIES "bam")
  include_directories(${ZLIB_INCLUDE_DIRS})
else (ZLIB_FOUND)
  message("WARNING: zlib not found!")
  set(SAMTOOLS_FOUND "0")
endif (ZLIB_FOUND)

include_directories(${CMAKE_INCLUDE_PATH})

################################################################################
# Set Path Variables
################################################################################

# Set SEQAN_LIBRARY if it has not been set yet (e.g. by using ccmake).
if (NOT SEQAN_LIBRARY)
  get_filename_component (SEQAN_LIBRARY_ABS .. ABSOLUTE)
  set (SEQAN_LIBRARY ${SEQAN_LIBRARY_ABS} CACHE PATH
       "Path to SeqAn's parent folder (contains apps,demos,seqan)")
endif (NOT SEQAN_LIBRARY)

# Path to and not including the "projects" directory.
get_filename_component (SEQAN_SOURCE_ROOT ${CMAKE_CURRENT_SOURCE_DIR}/../../.. ABSOLUTE)
get_filename_component (SEQAN_BINARY_ROOT ${CMAKE_CURRENT_BINARY_DIR}/../../.. ABSOLUTE)

set (SEQAN_TARGET "Seqan")

################################################################################
# Include paths for vendor copies of libraries.
################################################################################

INCLUDE_DIRECTORIES(${SEQAN_LIBRARY}/lib/samtools)

################################################################################
# Define SeqAn Library Related Variables
#
# We define some variables that contain the base path of the library,
# a list of all headers in SeqAn, the modules and generated forwards.
################################################################################

# Absolute path to "seqan" directory goes into SEQAN_BASE_ABS.
get_filename_component (SEQAN_BASE_ABS ${SEQAN_LIBRARY}/seqan ABSOLUTE)

# A sorted list of all SeqAn headers goes into SEQAN_HEADERS.  We
# exclude the generated headers.
file (GLOB SEQAN_HEADERS_TMP ${SEQAN_BASE_ABS}/[A-z]*/[A-z]*.h)
file (GLOB SEQAN_SUPER_HEADERS ${SEQAN_BASE_ABS}/[A-z]*.h)
foreach (HEADER ${SEQAN_HEADERS_TMP})
  if (NOT ${HEADER} MATCHES ".*generated.*")
    list (APPEND SEQAN_HEADERS ${HEADER})
  endif (NOT ${HEADER} MATCHES ".*generated.*")
endforeach (HEADER ${SEQAN_HEADERS})
list (SORT SEQAN_HEADERS)

# A sorted list of all SeqAn modules goes into SEQAN_MODULES.
file (GLOB SEQAN_BASE_CONTENTS
      RELATIVE ${SEQAN_BASE_ABS}
      ${SEQAN_BASE_ABS}/[A-z]*)
foreach (ENTRY ${SEQAN_BASE_CONTENTS})
  if (IS_DIRECTORY ${SEQAN_BASE_ABS}/${ENTRY})
    list (APPEND SEQAN_MODULES ${ENTRY})
  endif (IS_DIRECTORY ${SEQAN_BASE_ABS}/${ENTRY})
endforeach (ENTRY ${SEQAN_BASE_CONTENTS})
list (SORT SEQAN_MODULES)
list (REMOVE_DUPLICATES SEQAN_MODULES)

################################################################################
# CMake Bug Workarounds
################################################################################

# For Non-GUI generators there is a bug in cmake: The SOURCE command in
# add_custom_target is not recognized there
set (NONGUI_GENERATORS "Unix Makefiles" "MinGW Makefiles")
list (FIND NONGUI_GENERATORS ${CMAKE_GENERATOR} FOUND)
if (FOUND EQUAL -1)
  set (SEQAN_GUI_SOURCES SOURCES ${SEQAN_HEADERS} ${SEQAN_SUPER_HEADERS})
endif (FOUND EQUAL -1)

################################################################################
# Forwards Generation For g++ Version >= 4.0
################################################################################

if (CMAKE_COMPILER_IS_GNUCXX)
  # Build a list of generated forwards headers.  Goes into SEQAN_FORWARDS.
  foreach (MODULE ${SEQAN_MODULES})
    list (APPEND SEQAN_FORWARDS
          ${SEQAN_BASE_ABS}/${MODULE}/${MODULE}_generated_forwards.h)
  endforeach (MODULE ${SEQAN_MODULES})

  # Now tell CMake that the forward headers can be generated with
  # build_forwards.py
  add_custom_command (
    OUTPUT ${SEQAN_FORWARDS}
    COMMAND ${PYTHON_EXECUTABLE} ${SEQAN_LIBRARY}/misc/build_forwards.py
            ${SEQAN_BASE_ABS} all
    DEPENDS ${SEQAN_HEADERS})
endif (CMAKE_COMPILER_IS_GNUCXX)

################################################################################
# SeqAn Pseudo Target
#
# We create a target ${SEQAN_TARGET} that contains all SeqAn headers,
# sources and the generated forwards.
################################################################################

# Note that SEQAN_FORWARDS is not defined when not compiling with g++
# which implies no forwards generation for non-g++ compilers.
add_custom_target (${SEQAN_TARGET}
  DEPENDS ${SEQAN_HEADERS}
          ${SEQAN_FORWARDS}
          ${SEQAN_GUI_SOURCES}
)

# Group library headers into modules.
foreach (SEQAN_HEADER ${SEQAN_HEADERS})
  file (RELATIVE_PATH SEQAN_HEADER_REL ${SEQAN_BASE_ABS} ${SEQAN_HEADER})
  get_filename_component (SEQAN_MODULE ${SEQAN_HEADER_REL} PATH)
  source_group (${SEQAN_MODULE} FILES ${SEQAN_HEADER})
endforeach (SEQAN_HEADER)

# Installation of headers.
foreach (HEADER ${SEQAN_HEADERS} ${SEQAN_SUPER_HEADERS} ${SEQAN_FORWARDS})
    string(REPLACE ${CMAKE_CURRENT_BINARY_DIR}/${REL_PATH}/seqan "" NEW_PATH ${HEADER})
    string(REPLACE ${SEQAN_BASE_ABS} "" NEW_PATH ${NEW_PATH})
    string(REPLACE "//" "/" NEW_PATH ${NEW_PATH})
    install(FILES ${HEADER}
            RENAME seqan${NEW_PATH}
            DESTINATION include
            COMPONENT headers)
    #message("install(FILES ${HEADER} RENAME seqan${NEW_PATH} DESTINATION include COMPONENT headers)")
endforeach()

################################################################################
# Set Compiler Flags
################################################################################

# Make sure the compiler can find include files from the SeqAn library.
include_directories (${SEQAN_LIBRARY})

# We enable maximal warnings for the GCC.
if (CMAKE_COMPILER_IS_GNUCXX)
  # For the GCC, enable warnings.
  set (CMAKE_CXX_WARNING_LEVEL 4)
  set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -W -Wall -Wno-long-long")

  # Determine GCC version.
  message("Determining GCC version.")
  EXEC_PROGRAM(${CMAKE_CXX_COMPILER}
               ARGS --version
               OUTPUT_VARIABLE _GCC_VERSION)
  STRING(REGEX REPLACE ".* ([0-9])\\.([0-9])\\.([0-9]) .*" "\\1\\2\\3"
         _GCC_VERSION ${_GCC_VERSION})
  message("  GCC version is ${_GCC_VERSION}")

  # Add -Wno-longlong if the GCC version is < 4.0.0.  Add -pedantic flag
  # but disable warnings for variadic macros with GCC >= 4.0.0.  Earlier
  # versions warn because of anonymous variadic macros in pedantic mode
  # but do not have a flag to disable these warnings.
  if (400 GREATER _GCC_VERSION)
    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-long-long")
  else (400 GREATER _GCC_VERSION)
    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pedantic -Wno-variadic-macros")
  endif (400 GREATER _GCC_VERSION)

  # Force GCC to keep the frame pointer when debugging is enabled.
  # This is mainly important for 64 bit but does not get into the way
  # on 32 bit either at minimal performance impact.
  set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -fno-omit-frame-pointer")
  set(CMAKE_CXX_FLAGS_RELDEBUG "${CMAKE_CXX_FLAGS_RELEASE} -g")# -fno-omit-frame-pointer")
  
  # Pass CXX flags to flags.
  #set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DSEQAN_CXX_FLAGS_=\"${CMAKE_CXX_FLAGS}\"")
endif (CMAKE_COMPILER_IS_GNUCXX)

if (MSVC)
  # Warning level 3 for MSVC is disabled for now to see how much really bad warnings there are.
  #set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /W3  /wd4996 -D_CRT_SECURE_NO_WARNINGS")
  set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /W2  /wd4996 -D_CRT_SECURE_NO_WARNINGS")
  # Disable Microsoft C++ language extensions.
  # TODO(holtgrew): Re-disable again, Microsoft's header do not compile with this option! Look for a workaround.
  #set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /Za")
endif (MSVC)

################################################################################
# Set Default Build Type
################################################################################

IF(NOT CMAKE_BUILD_TYPE)
  SET(CMAKE_BUILD_TYPE Debug CACHE STRING
      "Choose the type of build, options are: Debug Release."
      FORCE)
ENDIF(NOT CMAKE_BUILD_TYPE)

################################################################################
# Define Convenience Macros
################################################################################

macro(SEQAN_ADD_EXECUTABLE seqan_target)

	# create a new target
	add_executable(${seqan_target} ${ARGN})

	# add dependency to SeqAn library
	add_dependencies (${seqan_target} ${SEQAN_TARGET})

	# optionally link against runtime-library
	if (${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
		target_link_libraries (${seqan_target} rt)
	endif (${CMAKE_SYSTEM_NAME} STREQUAL "Linux")

endmacro(SEQAN_ADD_EXECUTABLE seqan_target)

################################################################################
# Include Sub-Projects
################################################################################

add_subdirectory (libs)
add_subdirectory (apps)
add_subdirectory (demos)
add_subdirectory (tests)

# Install documentation.
install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/../docs
        DESTINATION share/seqan)

=== demos/Makefile ===
SEQAN = ..

# Link against runtime library on Linux systems
OS_NAME=$(shell uname)
ifeq ($(OS_NAME),Linux)
  LDFLAGS += -lrt
endif
CPPFLAGS += -I$(SEQAN)
CPPFLAGS += -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64
CPPFLAGS += -DSEQAN_ENABLE_DEBUG=0 -DSEQAN_ENABLE_TESTING=0
CPPFLAGS += -O3
CPPFLAGS += -W -Wall -pedantic -Wno-variadic-macros

all: $(basename $(wildcard *.cpp))
index: $(basename $(wildcard index_*.cpp))
graph: $(basename $(wildcard graph_*.cpp))
modifier: $(basename $(wildcard modifier_*.cpp))
file: $(basename $(wildcard file_*.cpp))
find: $(basename $(wildcard find_*.cpp))
clean:
	rm -f $(basename $(wildcard *.cpp))

=== cmake/apps/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6)
project (Seqan_Apps)

################################################################################
# For the apps, use assertions in debug mode, no assertions in
# release mode and never go into testing mode.
################################################################################

# Use CMake's package location functionality to find the directories of
find_package (OpenMP QUIET)
find_package (TR1)

set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS} ${SAMTOOLS_CXX_FLAGS} -DSEQAN_ENABLE_TESTING=0")
set (CMAKE_CXX_FLAGS_RELDEBUG "${CMAKE_CXX_FLAGS_RELDEBUG} -DSEQAN_ENABLE_DEBUG=0")
set (CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -DSEQAN_ENABLE_DEBUG=0")
set (CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -DSEQAN_ENABLE_DEBUG=1")

################################################################################
# Set path variables
################################################################################

# Make sure the compiler can find include files from the SeqAn.
include_directories (${SEQAN_LIBRARY})
link_directories (${SEQAN_LIBRARY}/lib)

################################################################################
# Applications
################################################################################

# TODO(holtgrew): Disable apps if dependencies are missing.  This would mean removing the automatic generation of targets but this invites errors anyway.

# pseudo-target to build all apps
add_custom_target (apps)

# Find targets automatically
get_filename_component (SEQAN_APPS_ABS ${SEQAN_LIBRARY}/apps ABSOLUTE)
file (GLOB SEQAN_APPS ${SEQAN_APPS_ABS}/[A-z]*)

file (GLOB RAZERS_HEADERS ${SEQAN_LIBRARY}/apps/razers/[A-z]*.h)
file (GLOB RAZERS2_HEADERS ${SEQAN_LIBRARY}/apps/razers2/[A-z]*.h)
file (GLOB SEQAN_TCOFFEE_HEADERS ${SEQAN_LIBRARY}/apps/seqan_tcoffee/[A-z]*.h)

# Manually set predefined sets of source files for some targets
set (APP_razers_SOURCES ${SEQAN_LIBRARY}/apps/razers/razers.cpp ${RAZERS_HEADERS})
set (APP_razers2_SOURCES ${SEQAN_LIBRARY}/apps/razers2/razers.cpp ${RAZERS2_HEADERS})
set (APP_micro_razers_SOURCES ${SEQAN_LIBRARY}/apps/micro_razers/micro_razers.cpp ${RAZERS_HEADERS})
set (APP_param_chooser_SOURCES ${SEQAN_LIBRARY}/apps/param_chooser/param_chooser.cpp ${RAZERS_HEADERS})

################################################################################
# Auto-generate headers.
################################################################################

foreach (APP_DIR ${SEQAN_APPS})
  if (EXISTS ${APP_DIR}/config.h.in)
    configure_file (${APP_DIR}/config.h.in
                    ${APP_DIR}/config.h)
  endif (EXISTS ${APP_DIR}/config.h.in)
endforeach (APP_DIR ${SEQAN_APPS})

################################################################################
# Build applications.
################################################################################

# Make sure the compiler can find object files from the TBB library.
link_directories (${SEQAN_LIBRARY}/lib)

foreach (APP_DIR ${SEQAN_APPS})
	file (RELATIVE_PATH APP_DIR_REL ${SEQAN_APPS_ABS} ${APP_DIR})

	# if there is no predefined set of files for this target
	# find the source files automatically
	if (NOT APP_${APP_DIR_REL}_SOURCES)
		file (GLOB APP_${APP_DIR_REL}_SOURCES ${APP_DIR}/[A-z]*.cpp ${APP_DIR}/[A-z]*.h ${APP_DIR}/[A-z]*.cu)
	endif (NOT APP_${APP_DIR_REL}_SOURCES)

	foreach (SRC ${APP_${APP_DIR_REL}_SOURCES})
		if (NOT EXISTS ${SRC})
#			message ("WARNING ${SRC} not found. Disabling ${APP_DIR_REL}.")
			set (APP_${APP_DIR_REL}_NOBUILD TRUE)
		endif (NOT EXISTS ${SRC})
	endforeach (SRC)

	# add target, dependencies and linked libraries
	set (SAVED_FLAGS ${CMAKE_CXX_FLAGS})
	if (APP_${APP_DIR_REL}_SOURCES)
		if (APP_${APP_DIR_REL}_NOBUILD)
			message ("Not building ${APP_DIR_REL} -- it is deactivated.")
		else (APP_${APP_DIR_REL}_NOBUILD)
			list (SORT APP_${APP_DIR_REL}_SOURCES)
			  add_executable (${APP_DIR_REL} ${APP_${APP_DIR_REL}_SOURCES})
			  install(TARGETS ${APP_DIR_REL}
			          DESTINATION bin
			          COMPONENT apps)
			add_dependencies (${APP_DIR_REL} ${SEQAN_TARGET})
			add_dependencies (apps ${APP_DIR_REL})
            # Link against libz everywhere, used for reading BAM, for example.
            if (ZLIB_FOUND)
			  target_link_libraries (${APP_DIR_REL} z)
            endif (ZLIB_FOUND)
            # Link against librt on Linux for real-time clock.
			if (${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
				target_link_libraries (${APP_DIR_REL} rt)
			endif (${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
			set (CMAKE_CXX_FLAGS ${SAVED_FLAGS})
		endif (APP_${APP_DIR_REL}_NOBUILD)
	endif (APP_${APP_DIR_REL}_SOURCES)
endforeach (APP_DIR)

# Install RazerS gapped parameters.
install(DIRECTORY ${SEQAN_LIBRARY}/apps/razers2/gapped_params
        DESTINATION bin)

=== cmake/demos/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6)
project (Seqan_Demos)

################################################################################
# For the demos, use assertions in debug mode, no assertions in
# release mode and never go into testing mode.
################################################################################

set (CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -DSEQAN_ENABLE_DEBUG=0 -DSEQAN_ENABLE_TESTING=0")
set (CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -DSEQAN_ENABLE_DEBUG=1 -DSEQAN_ENABLE_TESTING=0")

################################################################################
# Set path variables
################################################################################

include_directories (${SEQAN_LIBRARY})
link_directories (${SEQAN_LIBRARY}/lib)

################################################################################
# Demos
################################################################################

add_custom_target(demos)

file(GLOB SEQAN_DEMOS ${SEQAN_LIBRARY}/demos/[A-z]*.cpp)
foreach (DEMOFILE ${SEQAN_DEMOS})
	get_filename_component (DEMO ${DEMOFILE} NAME_WE)
	seqan_add_executable (${DEMO} ${DEMOFILE})
	add_dependencies (demos ${DEMO})
endforeach (DEMOFILE)

################################################################################
# Tutorials
################################################################################

add_custom_target(tutorials)

file(GLOB SEQAN_DEMOS ${SEQAN_LIBRARY}/demos/tutorial/[A-z]*.cpp
                      ${SEQAN_LIBRARY}/demos/tutorial/*/[A-z]*.cpp)
foreach (DEMOFILE ${SEQAN_DEMOS})
	get_filename_component (DEMO ${DEMOFILE} NAME_WE)
	seqan_add_executable (tutorial_${DEMO} ${DEMOFILE})
	add_dependencies (tutorials tutorial_${DEMO})
endforeach (DEMOFILE)

=== cmake/libs/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6)

################################################################################
# Include the CMakeLists.txt for each lib's directory.
################################################################################

get_filename_component (SEQAN_LIB_ABS ${SEQAN_LIBRARY}/lib ABSOLUTE)
file (GLOB SEQAN_LIBRARIES ${SEQAN_LIB_ABS}/[A-z]*)

foreach (LIBRARY_DIR ${SEQAN_LIBRARIES})
  get_filename_component(LIBRARY_NAME ${LIBRARY_DIR} NAME)
  if (EXISTS ${LIBRARY_DIR}/CMakeLists.txt)
    add_subdirectory(${LIBRARY_DIR} ${LIBRARY_NAME})
  endif (EXISTS ${LIBRARY_DIR}/CMakeLists.txt)
endforeach (LIBRARY_DIR ${SEQAN_LIBRARIES})

=== cmake/tests/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6)
project (Seqan_Tests)

# Some tests need OpenMP.
find_package (OpenMP QUIET)

################################################################################
# For the tests, we switch SeqAn into testing mode.
################################################################################

set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS} ${SAMTOOLS_CXX_FLAGS} -DSEQAN_ENABLE_DEBUG=1 -DSEQAN_ENABLE_TESTING=1")
# Also enable flags for coverage analysis.
if (MODEL STREQUAL "NightlyCoverage")
  if (CMAKE_COMPILER_IS_GNUCXX)
    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fprofile-arcs -ftest-coverage")
    set (LDFLAGS "${LDFLAGS} -fprofile-arcs -ftest-coverage")
  endif (CMAKE_COMPILER_IS_GNUCXX)
endif (MODEL STREQUAL "NightlyCoverage")
if (MODEL STREQUAL "ExperimentalCoverage")
  if (CMAKE_COMPILER_IS_GNUCXX)
    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fprofile-arcs -ftest-coverage")
    set (LDFLAGS "${LDFLAGS} -fprofile-arcs -ftest-coverage")
  endif (CMAKE_COMPILER_IS_GNUCXX)
endif (MODEL STREQUAL "ExperimentalCoverage")

################################################################################
# Set path variables
################################################################################

include_directories (${SEQAN_LIBRARY})
link_directories (${SEQAN_LIBRARY}/lib)

################################################################################
# Define which tests are to link against libbam.
################################################################################

MACRO(LIST_CONTAINS var value)
  SET(${var})
  FOREACH (value2 ${ARGN})
    IF (${value} STREQUAL ${value2})
      SET(${var} TRUE)
    ENDIF (${value} STREQUAL ${value2})
  ENDFOREACH (value2)
ENDMACRO(LIST_CONTAINS)

set(SEQAN_LINK_LIBBAM ${SEQAN_LINK_LIBBAM} test_store)

################################################################################
# Tests
################################################################################

add_custom_target(tests)

#-----------------------------------------------------------------------------
# Configure Dart testing support.  This should be done before any
# MESSAGE(FATAL_ERROR ...) commands are invoked.
INCLUDE(CTest)
ENABLE_TESTING()
IF(BUILD_TESTING)
  SET(BUILDNAME "${BUILDNAME}" CACHE STRING "Name of build on the dashboard")
  MARK_AS_ADVANCED(BUILDNAME)
ENDIF(BUILD_TESTING)

get_filename_component (SEQAN_TESTS_ABS ${SEQAN_LIBRARY}/../tests ABSOLUTE)
#if (EXISTS SEQAN_TESTS_ABS)
	file(GLOB SEQAN_TESTS ${SEQAN_TESTS_ABS}/[A-z]*)
	foreach (TEST_DIR ${SEQAN_TESTS})
		file (RELATIVE_PATH TEST_DIR_REL ${SEQAN_TESTS_ABS} ${TEST_DIR})
		file (GLOB TEST_SOURCES ${TEST_DIR}/[A-z]*.h ${TEST_DIR}/test_[A-z]*.cpp)
		list (SORT TEST_SOURCES)
		if (TEST_SOURCES)
			add_executable (test_${TEST_DIR_REL} ${TEST_SOURCES})
			add_dependencies (test_${TEST_DIR_REL} ${SEQAN_TARGET})
	    add_dependencies (tests test_${TEST_DIR_REL})

    # Conditionally link against libbam.
    if (SAMTOOLS_FOUND)
      LIST_CONTAINS(contains test_${TEST_DIR_REL} ${SEQAN_LINK_LIBBAM})
      if (contains)
        if (ZLIB_FOUND)
          target_link_libraries(test_${TEST_DIR_REL} ${SAMTOOLS_LIBRARIES} ${ZLIB_LIBRARIES})
        else (ZLIB_FOUND)
          target_link_libraries(test_${TEST_DIR_REL} ${SAMTOOLS_LIBRARIES})
        endif (ZLIB_FOUND)
      endif (contains)
    endif (SAMTOOLS_FOUND)

      # Create a variable with the paths to the tests for memory checks.
      # TODO(holtgrew): For MSVC the paths are different, but does not matter as not run on Windows yet.
      if (MODEL MATCHES ".*Mem.*Check")
        set(TEST_PATH ${SEQAN_BINARY_ROOT}/projects/library/cmake/tests/)
      endif (MODEL MATCHES ".*Mem.*Check")
			add_test (test_${TEST_DIR_REL} ${TEST_PATH}test_${TEST_DIR_REL})
			if (${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
				target_link_libraries (test_${TEST_DIR_REL} rt)
			endif (${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
		endif (TEST_SOURCES)
	endforeach (TEST_DIR)
#endif (EXISTS SEQAN_TESTS_ABS)

set (SEQAN_TESTS_APPS_DIR "${SEQAN_TESTS_ABS}/apps")

file(GLOB SEQAN_TESTS ${SEQAN_TESTS_APPS_DIR}/[A-z]*)
foreach (TEST_DIR ${SEQAN_TESTS})
  file (RELATIVE_PATH TEST_DIR_REL ${SEQAN_TESTS_APPS_DIR} ${TEST_DIR})
  if (MODEL MATCHES ".*Mem.*Check")
    add_test(test_apps_${TEST_DIR_REL} ${PYTHON_EXECUTABLE} ${TEST_DIR}/run_tests.py --valgrind ${SEQAN_SOURCE_ROOT} ${SEQAN_BINARY_ROOT})
  else (MODEL MATCHES ".*Mem.*Check")
    add_test(test_apps_${TEST_DIR_REL} ${PYTHON_EXECUTABLE} ${TEST_DIR}/run_tests.py ${SEQAN_SOURCE_ROOT} ${SEQAN_BINARY_ROOT})
  endif (MODEL MATCHES ".*Mem.*Check")
endforeach (TEST_DIR)

=== demos/extra/Makefile ===
SEQAN = ../..

# Link against runtime library on Linux systems
OS_NAME=$(shell uname)
ifeq ($(OS_NAME),Linux)
  LDFLAGS += -lrt
endif

CPPFLAGS += -I$(SEQAN)
CPPFLAGS += -O3
CPPFLAGS += -pedantic
CPPFLAGS += -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64

pizzachili: pizzachili.cpp $(SEQAN)/lib/libpizzachili.a
	$(CXX) $(CPPFLAGS) pizzachili.cpp -o $@ -L$(SEQAN)/lib -lpizzachili

$(SEQAN)/lib/libpizzachili.a:
	$(MAKE) -C $(SEQAN)/extra/pizzachili install
	
clean:
	rm -f $(basename $(wildcard *.cpp))

=== demos/tutorial/Makefile ===
SEQAN = ../..

# Link against runtime library on Linux systems
OS_NAME=$(shell uname)
ifeq ($(OS_NAME),Linux)
  LDFLAGS += -lrt
endif

CPPFLAGS += -I$(SEQAN)
CPPFLAGS += -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64
CPPFLAGS += -O3
CPPFLAGS += -pedantic

all: $(basename $(wildcard *.cpp))
index: $(basename $(wildcard index_*.cpp))
graph: $(basename $(wildcard graph_*.cpp))
modifier: $(basename $(wildcard modifier_*.cpp))
file: $(basename $(wildcard file_*.cpp))
find: $(basename $(wildcard find_*.cpp))
sequence: $(basename $(wildcard sequence/*.cpp))
clean:
	rm -f $(basename $(wildcard *.cpp))

=== debian/changelog ===
seqan (1.3.1-1) unstable; urgency=low

  * New upstream version
  * debian/watch: Adapt to new way to provide release archives
  * debian/orig-tar.sh:
     - Be less noisy
     - Provide fallback target dir in case .svn/deb-layout doese not
       exist - which is the case at least in my checkout
  * debian/control:
     - Standards-Version: 3.9.3 (no changes needed)
     - distinct short descriptions
  * debian/seqan-dev.doc-base: Provide doc-base control file
  * debian/rules + several debhelper files:
    Rely more on debhelper than manual moving around files to make
    debian/rules better maintaineable
  * debian/rules:
     - Do not specify single target files but rather use find to
       obtain files to move around
     - Save a copy of those files which will be removed by upstream
       clean target otherwise to enable building twice in a row

 -- Andreas Tille <tille@debian.org>  Mon, 23 Apr 2012 13:25:17 +0200

=== debian/control ===
Source: seqan
Section: science
Priority: optional
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Soeren Sonnenburg <sonne@debian.org>,
 Andreas Tille <tille@debian.org>
Build-Depends: cdbs, debhelper (>= 8), cmake, zlib1g-dev, libbam-dev, libboost-dev
Standards-Version: 3.9.3
Homepage: http://www.seqan.de/
Vcs-Browser: http://svn.debian.org/wsvn/debian-med/trunk/packages/seqan/
Vcs-Svn: svn://svn.debian.org/debian-med/trunk/packages/seqan/trunk/

Package: seqan-apps
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: C++ library for the analysis of biological sequences
 SeqAn is a C++ template library of efficient algorithms and data
 structures for the analysis of sequences with the focus on
 biological data. This library applies a unique generic design that
 guarantees high performance, generality, extensibility, and
 integration with other libraries. SeqAn is easy to use and
 simplifies the development of new software tools with a minimal loss
 of performance. This package contains the applications dfi, pair_align,
 micro_razers, seqan_tcoffee, seqcons, razers and tree_recon.

Package: seqan-dev
Section: libdevel
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: C++ library for the analysis of biological sequences (development)
 SeqAn is a C++ template library of efficient algorithms and data
 structures for the analysis of sequences with the focus on
 biological data. This library applies a unique generic design that
 guarantees high performance, generality, extensibility, and
 integration with other libraries. SeqAn is easy to use and
 simplifies the development of new software tools with a minimal loss
 of performance.
 .
 This package contains the developer files, documentation and examples.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/cmake.mk

DEB_SRCDIR              := cmake
DEB_MAKE_INSTALL_TARGET :=

DEB_DH_BUILDDEB_ARGS = -- -Zxz

## dh does not seem to propagate the correct options to cmake configure step
#%:
#	dh $@ --parallel --buildsystem=cmake

#override_dh_auto_build:
makebuilddir::
	# create backups of original *generated_forwards.h files to build twice in a row
	for header in `find seqan -name "*generated_forwards.h"` ; do \
	  mkdir -p orig/`dirname $$header` ; \
	  cp -a $$header orig/$${header} ; \
	done
#	dh_auto_build

#override_dh_auto_install:
#	dh_auto_install
install/seqan-apps:: debian/stamp-install-seqan-apps
debian/stamp-install-seqan-apps:
	#install binaries
	for APP in `find $(CURDIR)/obj*/apps -mindepth 1 -maxdepth 1 -executable -type f` ; do \
	  cp -a $$APP $(CURDIR)/debian/seqan-apps/usr/lib/sequan/bin/ ; done
	#install readmes
	for APP in `find apps -name README` ; do \
	  app=`echo $$APP | sed 's?.*apps/\(.\+\)/README?\1?'` ; \
	  echo $$app ; \
	  cp -a $$APP $(CURDIR)/debian/seqan-apps/usr/share/doc/seqan-apps/README.$$app ; \
	done

# Delete extra license files
install/seqan-dev::
	@echo "This should be post-install action after installing files for seqan-dev ... but the doc is lying :-("
	find debian -type f -name LICENSE -delete
	# FIXME: Anybody able to convince cdbs to do what the doc is promising and remove the unneeded LICENSE files?

#override_dh_auto_clean:
#	dh_auto_clean
clean::
	if [ -d orig ] ; then \
	  for header in `find orig -name "*generated_forwards.h"` ; do \
	    mv $${header} `echo $$header | sed 's?orig/??'` ; \
	  done ; \
	fi
	rm -rf orig

get-orig-source:
	uscan --force-download
	@echo successfully retrieved upstream tarball

=== debian/watch ===
version=3
http://ftp.seqan.de/releases/seqan-([.\d]+)\.zip \
   debian debian/orig-tar.sh
